#ifndef DEBUG_H
#define DEBUG_H

/*
** debug.h
**
** $VER: debug.h 1.0 (11.09.97)
**
** Created by Stefan Ruppert, modifyed by Martin Gierich for midi.datatype.
*/


#define bug      kprintf

#ifdef DEBUG

extern void kprintf(char *fmt,...);

#define D(x)    x
#define DB(x)   { bug(__FILE__ "(%4ld):" __FUNC__ "() :",__LINE__); \
                  bug x; \
                }
#define ENTERING  bug("entering " __FUNC__ "()\n")
#define LEAVING   bug("leaving " __FUNC__ "()\n")

#else

#define D(x)
#define DB(x)
#define ENTERING
#define LEAVING

#endif

#endif   /* DEBUG_H */
