#ifndef DATATYPES_MIDI_H
#define DATATYPES_MIDI_H

/*
** $PROJECT: midi.datatype
**
** $VER: midiclass.h 40.0 (11.09.97)
**
** Interface definitions for DataType midi objects.
** 
** Copyright 1997 by Martin Gierich.
** All Rights Reserved !
**
** $HISTORY:
** 11.09.97 : 40.00 : Initial BETA release
**
** $TABSIZE: 8
*/


/* ------------------------------- includes ------------------------------- */

#include <exec/types.h>
#include <utility/tagitem.h>
#include <datatypes/datatypesclass.h>
#include <intuition/intuition.h>
#include <libraries/gadtools.h>


/* ------------------------------ class name ------------------------------ */

#define MIDIDTCLASS	"midi.datatype"


/* -------------------- new methods for midi.datatype --------------------- */
/* (none yet) */


/* ------------------------------ attributes ------------------------------ */

#define MDTA_Dummy	(DTA_Dummy + 0x880)
#define MDTA_Cluster	(MDTA_Dummy + 0x01)
#define MDTA_Buffer	(MDTA_Dummy + 0x02)
#define MDTA_BufferLen	(MDTA_Dummy + 0x03)


/* ------------------------------ structures ------------------------------ */

/* Private structure used by midi.datatype */
/* Do not use this in applications ! */
struct MidiDTData
{
	/* General */
	UBYTE		*mdt_Buffer;
	UBYTE		*mdt_BufferEnd;
	ULONG		 mdt_BufferLen;
	UWORD		 mdt_Flags;
	UBYTE		 mdt_FileName[256];
	UBYTE		 mdt_Name[32];

	/* Player */
	UWORD		 mdt_Volume;
	UWORD		 mdt_Cycles;
	struct Task	*mdt_SignalTask;
	ULONG		 mdt_SignalBit;
	BOOL		 mdt_Immediate;
	BOOL		 mdt_Repeat;
	struct Process	*mdt_PlayProc;
	UBYTE		 mdt_Playing;
	UBYTE		 mdt_Cluster[31];

	/* User Interface */
	struct IBox	*mdt_Domain;

	/* GadTools gadgets
	void		*mdt_gtvisual;
	struct Gadget	*mdt_gtcontext;
	struct Gadget	*mdt_gtlist;
	struct NewGadget mdt_gtnew; */
};

/* mdt_Flags */
#define MDTF_ALLOCATED         (1<<1)
#define MDTF_NEEDLAYOUT        (1<<2)
#define MDTF_NEEDRENDERING     (1<<3)


#endif /* !DATATYPES_MIDI_H */

